#ifndef __BOILERPLATE_PREFERENCES_VIEW_H__
#define __BOILERPLATE_PREFERENCES_VIEW_H__

#include "boilerplate-preferences-page.h"

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define BOILERPLATE_TYPE_PREFERENCES_VIEW (boilerplate_preferences_view_get_type ())

G_DECLARE_FINAL_TYPE (BoilerplatePreferencesView, boilerplate_preferences_view, BOILERPLATE, PREFERENCES_VIEW, GtkBin)

BoilerplatePreferencesView *
boilerplate_preferences_view_new (void);

void
boilerplate_preferences_view_add_page (BoilerplatePreferencesView *self,
                                       const gchar                *page_name,
                                       const gchar                *page_title);
void
boilerplate_preferences_view_add_page_with_child (BoilerplatePreferencesView *self,
                                                  const gchar                *page_name,
                                                  const gchar                *page_title,
                                                  GtkWidget                  *child);
void
boilerplate_preferences_view_add_child_to_page (BoilerplatePreferencesView *self,
                                                const gchar                *page_name,
                                                GtkWidget                  *child);

void
boilerplate_preferences_view_add_group (BoilerplatePreferencesView *self,
                                        const gchar                *page_name,
                                        const gchar                *group_name,
                                        const gchar                *group_title);

void
boilerplate_preferences_view_add_option_row (BoilerplatePreferencesView *self,
                                             const gchar                *page_name,
                                             const gchar                *group_name,
                                             GtkWidget                  *widget);

GtkWidget *
boilerplate_preferences_view_get_page (BoilerplatePreferencesView *self,
                                       const gchar                *page_name);

GtkWidget *
boilerplate_preferences_view_get_group (BoilerplatePreferencesView *self,
                                        const gchar                *page_name,
                                        const gchar                *group_name);

void
boilerplate_preferences_view_add_switch (BoilerplatePreferencesView *self,
                                         const gchar                *page_name,
                                         const gchar                *group_name,
                                         const gchar                *schema,
                                         const gchar                *key,
                                         const gchar                *name,
                                         const gchar                *description);

G_END_DECLS

#endif /* __BOILERPLATE_PREFERENCES_VIEW_H__ */
